import React from 'react';
import { DataType, Props, RegisterInput, OnSubmit } from './types';
export default function useForm<Data extends DataType, Name extends keyof Data = keyof Data>({ mode, validationSchema, defaultValues, validationFields, nativeValidation, submitFocusError, }?: Props<Data>): {
    register: (refOrValidateRule: any, validateRule?: RegisterInput | undefined) => ((ref: any) => void) | undefined;
    unregister: (name: string | string[]) => void;
    handleSubmit: (callback: OnSubmit<Data>) => (e: React.SyntheticEvent<Element, Event>) => Promise<void>;
    watch: (fieldNames?: string | string[] | undefined, defaultValue?: string | Partial<Data> | undefined) => any;
    unSubscribe: () => void;
    reset: () => void;
    clearError: (name: Name) => void;
    setError: (name: Name, type: string, message?: string | undefined, ref?: any) => void;
    setValue: (name: Name, value: Data[Name], shouldValidate?: boolean) => void;
    triggerValidation: (payload?: {
        name: Name;
        value?: Data[Name] | undefined;
    } | {
        name: Name;
        value?: Data[Name] | undefined;
    }[] | undefined) => Promise<boolean>;
    getValues: (payload?: {
        nest: boolean;
    } | undefined) => Data;
    errors: import("./types").ObjectErrorMessages<Data>;
    formState: {
        isValid: boolean;
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: unknown[];
        isSubmitting: boolean;
    };
};
